# Die Anwendung (APP)

Um den Funktionsablauf des Endproduktes besser zu verstehen, wird hier näher auf die App eingegangen. Es wird erklärt, welche Funktionen enthalten sind und was zu erwarten ist, quasi wie eine kleine Betriebsanleitung.

## Home und Navigation

<img src="assets/sreenshots/screen_home.png" alt="" style="width: 25%;"/>

Auf dem Home Screen gibt es nicht viel zu sehen, lediglich den Hardware-Controller. Unter (1) kann die Navigation (siehe folgende Abbildung) aufgerufen werden. Alternativ kann diese mit einem Swipe von links nach rechts aufgerufen werden.

<img src="assets/sreenshots/screen_navigation.png" alt="" style="width: 25%;"/>

Hier werden die verschiedenen Menüpunkte aufgelistet:

1. `Home`: Der Startbildschirm
2. `Connect Device`: Die Funktionalität, eine Verbindung mit dem Gerät aufzubauen und dieses auf der Cloud zu registrieren.
3. `Registered Devices`: Eine Liste von Geräten, welche in der Cloud registriert sind.
4. `Settings`: Einstellungen zur Verbindung mit der Cloud (Hostname, Username, Password)

## Settings (Einstellungen)

<img src="assets/sreenshots/screen_settings.png" alt="" style="width: 25%;"/>

Für die volle Funktionstüchtigkeit benötigt die App drei Angaben:

1. die URL (Host ohne Schema und Pfad)
2. Benutzername für den Zugriff auf die Daten
3. Passwort für den Benutzer

Sollten diese Daten nicht gegeben sein, kann die App nicht auf die Cloud zugreifen.

## Connect Devices (Registrierung des Gerätes)

Für die Nutzung von Bluetooth erfordert die App Standort-Berechtiungungen. Beim Aufrufen der Scan-Funktion wird diese über ein Popup angefragt. Wenn ein Scann gestartet wird, öffnet sich ein zweites Fenster. Für eine bessere Funktionalität sollte der präzise Standort ausgewählt werden. 

Es wird kein GPS verwendet, um den Standort von Nutzern auszulesen! 

<img src="assets/sreenshots/screen_discovery_permissions-1.png" alt="" style="width: 25%;"/>

<img src="assets/sreenshots/screen_discovery_permissions-2.png" alt="" style="width: 25%;"/>

Nachdem die Berechtigungen erteilt wurden, erscheint die Discovery Page. Diese dient dazu, Bluetooth Geräte aus der Nähe anzuzeigen und eine Verbindung aufzubauen. 

<img src="assets/sreenshots/screen_discovery.png" alt="" style="width: 25%;"/>

Eine Liste aus Bluetooth-Adaptern in der Nähe wird mit Gerätenamen (falls verfügbar) und zugehöriger Hardware-Adresse angezeigt. Ein kurzer Klick auf den Eintrag startet eine Bluetooth Verbindung, ein langer Klick das Bluetooth Pairing.

Legende:

1. Ein Button, um zur Startseite zurück zu kehren. Wird dieser ausgelöst, werden alle bestehenden Verbindungen getrennt
2. Entweder ein Indikator, um einen Suchvorgang anzuzeigen oder ein Button, um die Suche neu zu starten
3. Eine Checkliste um die Voraussetzungen zu prüfen. Wenn beide Harken grün sind, ist die Suche funktionstüchtig. Beide Textfelder können angeklickt werden, um notwendige Änderungen durchzuführen.
4. Sollten die Harken nicht grün sein und ein klick auf's Textfeld nicht geholfen haben, kann man hier für Benutzerrechte auf den zugehörigen Screen wechseln.
5. Ein Indikator, falls eine Verbindung mit dem Gerät hergestellt wurde (blaues Icon)
6. Zeigt an, ob das Gerät gepairt wurde
7. Zeigt die Signalstärke an
8. Hier wird der nächste Schritt nach einer Verbindung gestartet

<img src="assets/sreenshots/screen_device-settings.png" alt="" style="width: 25%;" style="width: 25%;"/>

Dieser Screen führt die letzten Schritte durch. Eine Übersicht optionaler Gerätedaten wird aufgelistet. Zusätzlich mit zwei Buttons, um das Gerät erneut zu verbinden oder die Verbindung zu trennen.

Darunter ist ein Textfeld gegeben. Hier wird die künftige ID des Gerätes eingetippt, und kann mit dem Button rechts bestätigt werden. Bei einer Bestätigung wird zunächst die Verfügbarkeit der ID in der Cloud geprüft. Sollte die ID (nicht) verfügbar sein, wird untem auf dem bildschirm eine kurze Benachrichtigung angezeigt (siehe folgende Abbildung). Danach wird dir ID an das Gerät geschickt. Das Gerät Antwortet mit einem Fingerprint, welcher zur Registrierung des Gerätes verwendet wird. Für diesen Prozess fehlt der Ladeindikator, denn es benötigt ein wenig Geduld. Sollte die Registrierung (nicht) funktioniert haben, wird der Nutzer über ein Popup informiert (siehe zweite folgende Abbildung).

<img src="assets/sreenshots/screen_device-settings_available.png" alt="" style="width: 25%;"/>

<img src="assets/sreenshots/screen_device-settings_registered.png" alt="" style="width: 25%;"/>

Lief der Prozess wie abgebildet ab, ist das Gerät erfolgreich registriert wurden und ist einsatzbereit.

## Registered Device (bereits registrierte Geräte)

<img src="assets/sreenshots/screen_registered-devices.png" alt="" style="width: 25%;"/>

Dieser Screen zeigt eine Liste von in der Cloud registrierten Geräten an. Diese werden anhand ihrer ID angezeigt. Hier kann überprüft werden, ob die verwendete ID auch in der Cloud gelistet ist.

Legende:

1. Ein Suchfeld, um die Liste zu filtern
2. Ein Button, um die Suche zu bestätigen
3. Entweder ein Indikator, um einen Suchvorgang anzuzeigen oder ein Button, um die Suche neu zu starten
4. Der Listeneintrag (kann angeklickt werden)

Wenn der Listeneintrag ausgewählt wird, erscheint ein Popup.

<img src="assets/sreenshots/screen_registered-devices_info.png" alt="" style="width: 25%;"/>

Das Popup zeigt sämtliche hinterlegte Informationen zu einem Eintrag in der Cloud an. Entweder wird die Anzeige für genannte Informationen verwendet, oder das Gerät kann über Remote aus der Cloud entfernt werden.

