# Das Projekt

`Titel`: Out-Of-Band Provisioning für industrielle IoT Geräte

## Kurze Projektbeschreibung:

Die Provisionierung, also die initiale Einrichtung, von IoT-Geräten ist in vielen Szenarien eine Herausforderung. Oft ist es nicht möglich Geräte vollständig konfiguriert auszuliefern. Die finale Konfiguration erfolgt dann erst im Feld durch die Anwender:innen. Eine besondere Herausforderung ist hierbei das Einrichten der Netzwerk- und Authentifizierungsdaten. Bei sogenannten Out-of-Band (OOB) Verfahren wird hierfür ein weiterer Kommunikationsweg wie WLAN, Bluetooth oder NFC genutzt. Für IoT-Geräte im Consumerbereich wird dies oft mit einer App, sicher und nutzerfreundlich umgesetzt.

## Ziel des Semesterprojektes

Dieses Verfahren soll für die Provisionierung einer linuxbasierten Steuerung umgesetzt werden. Dafür werden zwei Implementierungen berücksichtigt:
1. Der Provisionierungsprozess seitens der Steuerung
2. Eine App, dich sich mit der Steuerung über Bluetooth verbindet und diesen Prozess auslöst und das Gerät in der Cloud registriert.

## Verfahren im Überblick

<img src="assets/diagrams/ablauf_allgemein.jpg" alt="allgemeiner ablauf" style="width:100%;"/>

Der allgemeine Ablauf besteht zunächst aus drei Komponenten: Einem Azure IoT Hub (künftig referenziert als die Cloud), einem WAGO PFC200 (künftig referenziert als das Gerät) mit Bluetooth-Dongle und einem Android-Smartphone mit einer eigens angefertigten App.
Im Konzept verbindet sich die App mit einem passenden Bluetooth-Dongle. Über die Verbindung wird dem Gerät erklärt, welche ID es erhält, woraufhin auf dem Gerät ein Zertifikat erzeugt wird. Das Gerät überträgt ein Fingerprint des Zertifikates per Bluetooth an das Smartphone. Mit der ID und dem Fingerprint wird das Gerät über die App auf der Cloud registriert. Sollte das Gerät korrekt konfiguriert sein, kann nun die Cloud mit dem Gerät kommunizieren. Der genauere Verbindungsablauf wird folgend schematisch dargestellt:

<img src="assets/diagrams/provisionierungssequenz.drawio.jpg" alt="provisionierungssequenz" style="width:100%;"/>
